### 全局安装的webpack版本，要与项目中的版本一直，否则运行失败

启动命令：webpack-dev-server --contentbase src --inline--hot

* 第1章 课程简介
  * 课程导读，介绍了课程的基本结构、课程的特点、最终实战项目演示、前置知识点以及源码打包结构和后期相关学习资料的更新方式。
  * react基础知识：
* 1、组件基础
  * 1.react虚拟dom概念，这是react性能高效的核心算法
  * 2.react组件，理解什么叫做组件化
  * 3.react多组件嵌套
  * 4。jsx内置表达式
  * 5.生命周期，纵观整个react的生命周期
* 2、属性与事件
  * 1.state属性，控制着react的一切
  * 2.props属性
  * 3.事件与数据的双向绑定，包含数字页面之间的参数互传
  * 4.可复用组件，真正让react开发快速、高效的地方
  * 5.组件的refs
  * 6.独立组件间共享Mixins
* 3、样式
  * 1.内联样式
  * 2.内联样式中的表达式
  * 3.css模块化，学习如何使用require进行样式的引用
  * 4.jsx样式与css的互转
  * 5.一个非常好用的样式框架Ant Design 样式框架介绍
  * 6.Ant Design 样式框架使用
* 4、路由
  * 1.Router概念
  * 2.参数传递

* 第2章 React 简介
    * 对 React 进行了详细地简介并对课程的前置知识点进行了详细地梳理。

* 第3章 React 初体验
    * 介绍了此课程中使用的 React 版本以及官网学习包 React Starter Pack 的下载与安装，并对 React 的框架运行进行了初体验。

* 第4章 NodeJS简介与安装
    * 对 NodeJS 进行了详细地介绍，并完整演示了 NodeJS 的安装过程。同时讲解了针对国内的网络环境如何去配置 NPM 加载国内源。

* 第5章 React 环境配置与调试技巧
    * 共计五个小节，讲解了使用 NPM 配置 React 的开发环境。并分三个小节课程由浅入深地讲解了前端必备组件 webpack 的热加载配置。同时还介绍了 React 开发的必备插件 Chrome React 插件。

* 第6章 开发工具与必要组件
    * 讲解了开发工具 Atom 的基本使用，并用一个单独的章节介绍了 React 开发相关 Atom 插件配置，这将大大提高开发 React 项目的效率。

* 第7章 React 组件基础
    * 共计五个小节，详细讲解了 React 虚拟 DOM 概念、React 组件的概念、React 多组件嵌套、JSX 内置表达式、生命周期，并都有详细的源码演示。这些 React 组件基础是 React 最基础也是最重要的知识点。

* 第8章 React 属性与事件
    * 共计六个小节，继续用概念和源码结合的方式对 State 属性、Props 属性、事件与数据的双向绑定、可复用组件、组件的 Refs、独立组件间共享 Mixins 这些重要的概念进行了深入地讲解与演示。

* 第9章 React 样式
    * 共计六个小节，还是用概念和源码结合的方式对 React 中的内联样式、内联样式中的表达式、CSS 模块化、JSX 样式与 CSS 的互转、Ant Design 样式框架介绍、Ant Design 样式框架使用这几个重要的知识点进行了讲解。

* 第10章 React Router
    * 用一个独立的大章节介绍了 React 中的重要概念：React Router 概念以及 React Router 的参数传递。

* 第11章 项目实战-开发环境初始化
    * 实战项目初始化，分别用四个小节课程介绍了项目初始化、Ant Design 框架的引入、头条新闻的数据接口简介、测试环境介绍。

* 第12章 项目实战-页头页脚模块
    * 实战项目的页头页脚开发，分别包含了PC 端页头组件开发、移动端页头组件开发、PC 端页脚组件开发、移动端页脚组件开发，并且每个独立的章节对有对应的独立源码文件夹供下载学习。

* 第13章 项目实战-注册登录模块
    * 共七个小节课程，分别实际源码演示开发了 PC 端注册功能模块开发（上中下）、移动端注册功能模块开发、PC 端登录功能模块开发、移动端登录功能模块开发、退出登录功能完善。

* 第14章 项目实战-首页模块
    * 用九个小节的课程继续实战开发了 PC 端导航栏布局开发、移动端导航栏模块开发、首页模块划分、PC 端首页模块布局开发（上）、PC 端首页模块布局开发（中）、PC 端首页模块布局开发（下）、移动端首页模块布局开发（上）、移动端首页模块布局开发（中）、移动端首页模块布局开发（下）。...

* 第15章 项目实战-详情模块
    * 继续用是十一个小节的课程继续实战开发了 PC 端详情页面开发（上）、PC 端详情页面开发（中）、PC 端详情页面开发（下）、移动端详情页面开发、评论模块开发（上）、评论模块开发（中）、评论模块开发（下）、移动端评论模块开发、PC 端用户收藏功能开发（上）、PC 端用户收藏功能开发（下）、移动端用户收藏功能开发...

* 第16章 项目实战-个人中心模块
    * 进行了项目的最后收尾开发，实战演示了 PC 端用户个人中心开发、移动端用户个人中心开发、个人头像的上传与处理、个人收藏文章列表开发（上）、个人收藏文章列表开发（下）、个人评论列表开发（上）、个人评论列表开发（下）共七个小节的功能开发，且仍然提供了独立的源码文件夹供下载学习或二次开发。...

* 第17章 项目实战-最后调优
    * 进行了整个实战项目的总结，并演示了在 React 中如何快速使用 HTML 代码块，同时将完整的课程思维导图分享给了大家。

